
#
# Portions of this file Copyright 1999-2005 University of Chicago
# Portions of this file Copyright 1999-2005 The University of Southern California.
#
# This file or a portion of this file is licensed under the
# terms of the Globus Toolkit Public License, found at
# http://www.globus.org/toolkit/download/license.html.
# If you redistribute this file, with or without
# modifications, you must include this notice in the file.
#

my $gpath = $ENV{GPT_LOCATION};

if (!defined($gpath))
{
  $gpath = $ENV{GLOBUS_LOCATION};
}

if (!defined($gpath))
{
   die "GPT_LOCATION or GLOBUS_LOCATION needs to be set before running this script"
}

@INC = (@INC, "$gpath/lib/perl");

require Grid::GPT::Setup;

my $metadata = new Grid::GPT::Setup(package_name => "globus_rls_server_setup");

my $globusdir = $ENV{GLOBUS_LOCATION};

if((!defined($globusdir)))
{
    die "GLOBUS_LOCATION needs to be set before running this script"
}

my $shell = $ENV{GLOBUS_SH};
if (!defined($shell)) {
  $shell = "/bin/sh";
}

my $mysql = $ENV{GLOBUS_MYSQL_PATH};
if (!defined($mysql)) {
  $mysql = "$globusdir";
}

my $iodbc = $ENV{GLOBUS_IODBC_PATH};
if (!defined($iodbc)) {
  $iodbc = "$globusdir";
}

my $odbcini = $ENV{ODBCINI};
if (!defined($odbcini)) {
  $odbcini = "$globusdir/var/odbc.ini";
}

my $setupdir = "$globusdir/setup/globus";

for my $f ("SXXrls", "globus-rls-server.conf", "rls-ldif.conf") {
  print "creating $f\n";
  open(FIN, "<$setupdir/${f}.in") || die "Can't find $setupdir/${f}.in";
  open(FOUT, ">$setupdir/${f}") || die "Can't open $setupdir/${f}.in";
  while (<FIN>) {
    s/\@GLOBUS_LOCATION\@/$globusdir/g;
    s/\@GLOBUS_MYSQL_PATH\@/$mysql/g;
    s/\@GLOBUS_IODBC_PATH\@/$iodbc/g;
    s/\@ODBCINI\@/$odbcini/g;
    s/\@SHELL\@/$shell/g;
    print FOUT;
  }
  close FIN;
  close FOUT;
}

system("cp $setupdir/SXXrls $globusdir/sbin/.");
system("chmod 0755 $globusdir/sbin/SXXrls");

if (-e "$globusdir/etc/globus-rls-server.conf") {
  print "$globusdir/etc/globus-rls-server.conf already exists, not replacing with $setupdir/globus-rls-server.conf\n";
} else {
  system("cp $setupdir/globus-rls-server.conf $globusdir/etc/.");
  system("chmod 0600 $globusdir/etc/globus-rls-server.conf");
}

system("cp $setupdir/rls-ldif.conf $globusdir/etc/.");
system("chmod 0644 $globusdir/etc/rls-ldif.conf");

print "Done\n";

$metadata->finish();
